/*Begin of head for every patch*/
if exists(select * from "DBA"."subRegistry" WHERE registryid='System'and subregistryid='Patch')
then  
   Delete from SubRegistry where registryid='System'and subregistryid='Patch'
end if;
/*End of head for every patch*/

/*----------------------------------------------------------------------------*/
/* To insert Malaysia Tax for Resident 2021 (For TaxPolicyId = DefaultPolicy) */
/*----------------------------------------------------------------------------*/
if exists(select 1 from sys.sysprocedure where proc_name = 'PatchMalaysiaTaxPolicyForRes') then
   drop PROCEDURE PatchMalaysiaTaxPolicyForRes
end if;
CREATE PROCEDURE "DBA"."PatchMalaysiaTaxPolicyForRes"()
begin
  declare MaxID integer;
  declare In_MalTaxPolicyProgSysId integer;
  declare Out_ErrorCode integer;
 
  /* Check for Malaysia DB */
  if FGetDBCountry(*) <> 'Malaysia' then return
  end if;
  /* Check Tax Policy */
  if not exists(select * from MalTaxPolicy where MalTaxPolicyId = 'DefaultPolicy') then 
	return;
  end if;
  /* Check for Tax Policy Progression*/
  if exists(select * from MalTaxPolicyProg where MalTaxPolicyEffDate = '2021-01-01' and MalTaxPolicyId = 'DefaultPolicy') then return;
  end if;
 
  /* Check for STD Policy */
  if not exists(select* from MalSTDPolicy where MalSTDPolicyId = 'ResYear2021') then
    insert into MalSTDPolicy(MalSTDPolicyId, MalSTDPolicyDesc, MalSTDFormula1Ratio, MalTaxScheme) values('ResYear2021','Year 2021 MTD Formula for Resident',0,'Resident');
    select Max(MalSTDPolicySysId) into MaxID from MalSTDPolicyTable;
	Insert into MalSTDPolicyTable(MalSTDPolicySysId, MalSTDPolicyId, Mal_PFrom, Mal_PTo, Mal_M, Mal_R, Mal_BCat13, Mal_BCat2) Values(MaxID+1,'ResYear2021','5001','20000','5000','1','-400','-800');
	Insert into MalSTDPolicyTable(MalSTDPolicySysId, MalSTDPolicyId, Mal_PFrom, Mal_PTo, Mal_M, Mal_R, Mal_BCat13, Mal_BCat2) Values(MaxID+2,'ResYear2021','20001','35000','20000','3','-250','-650');
	Insert into MalSTDPolicyTable(MalSTDPolicySysId, MalSTDPolicyId, Mal_PFrom, Mal_PTo, Mal_M, Mal_R, Mal_BCat13, Mal_BCat2) Values(MaxID+3,'ResYear2021','35001','50000','35000','8','600','600');
	Insert into MalSTDPolicyTable(MalSTDPolicySysId, MalSTDPolicyId, Mal_PFrom, Mal_PTo, Mal_M, Mal_R, Mal_BCat13, Mal_BCat2) Values(MaxID+4,'ResYear2021','50001','70000','50000','13','1800','1800');
	Insert into MalSTDPolicyTable(MalSTDPolicySysId, MalSTDPolicyId, Mal_PFrom, Mal_PTo, Mal_M, Mal_R, Mal_BCat13, Mal_BCat2) Values(MaxID+5,'ResYear2021','70001','100000','70000','21','4400','4400');
	Insert into MalSTDPolicyTable(MalSTDPolicySysId, MalSTDPolicyId, Mal_PFrom, Mal_PTo, Mal_M, Mal_R, Mal_BCat13, Mal_BCat2) Values(MaxID+6,'ResYear2021','100001','250000','100000','24','10700','10700');
	Insert into MalSTDPolicyTable(MalSTDPolicySysId, MalSTDPolicyId, Mal_PFrom, Mal_PTo, Mal_M, Mal_R, Mal_BCat13, Mal_BCat2) Values(MaxID+7,'ResYear2021','250001','400000','250000','24.5','46700','46700');
	Insert into MalSTDPolicyTable(MalSTDPolicySysId, MalSTDPolicyId, Mal_PFrom, Mal_PTo, Mal_M, Mal_R, Mal_BCat13, Mal_BCat2) Values(MaxID+8,'ResYear2021','400001','600000','400000','25','83450','83450');
	Insert into MalSTDPolicyTable(MalSTDPolicySysId, MalSTDPolicyId, Mal_PFrom, Mal_PTo, Mal_M, Mal_R, Mal_BCat13, Mal_BCat2) Values(MaxID+9,'ResYear2021','600001','1000000','600000','26','133450','133450');
	Insert into MalSTDPolicyTable(MalSTDPolicySysId, MalSTDPolicyId, Mal_PFrom, Mal_PTo, Mal_M, Mal_R, Mal_BCat13, Mal_BCat2) Values(MaxID+10,'ResYear2021','1000001','2000000','1000000','28','237450','237450');
	Insert into MalSTDPolicyTable(MalSTDPolicySysId, MalSTDPolicyId, Mal_PFrom, Mal_PTo, Mal_M, Mal_R, Mal_BCat13, Mal_BCat2) Values(MaxID+11,'ResYear2021','2000001','999999999','2000000','30','517450','517450');
  end if;
  
  /* Create Tax Policy Progression */
  select Max(MalTaxPolicyProgSysId) into In_MalTaxPolicyProgSysId from MalTaxPolicyProg;
  insert into MalTaxPolicyProg(
	MalTaxPolicyProgSysId, 
	MalTaxPolicyId, 
	MalSTDPolicyId, 
	MalTaxPolicyEffDate, 
	MalChildOutside, 
	MalChildInside,
	MalChildDisabled, 
	MalCat1Relief, 
	MalCat2ChildRelief, 
	MalCat2Relief, 
	MalCat3ChildRelief, 
	MalCat3Relief, 
	EPFCappingOption, 
	EPFCappingYearly, 
	EPFCappingMOnthly, 
	MalTaxCompenPerYr, 
	MalTaxMinTaxAmt)  
    values(In_MalTaxPolicyProgSysId+1,'DefaultPolicy','ResYear2021','2021-01-01',4,4,3,0,0,0,0,0,0,0,0,0,10);

  if not exists(select * from RebateItem where RebateID = 'Domestic Tourism') then
	insert into RebateItem(RebateID,RebateDesc,RebateERApproval,RebateProperty) values('Domestic Tourism','Accommodation fee at registered premises and Entrance fees to tourist attraction centre',1,'');
  end if;
  
  if not exists(select * from RebateItem where RebateID = 'Lifestyle - Sport') then
	insert into RebateItem(RebateID,RebateDesc,RebateERApproval,RebateProperty) values('Lifestyle - Sport','Purchase of sport equipment, rental or registration fee',1,'');
  end if;
	
  /* Update Rebates capping
		1. SAP 3261 - Disabled spouse from 3500 to 5000
		2. SAP 3264 - Parent Medical from 5000 to 8000
		3. SAP 3266 - Serious Medical from 6000 to 8000
		4. SAP 3268 - Lifestyle Relief remains at 2500
		5. SAP 3270 - Compensation from 10000 to 20000
		6. SAP 3283 - Kindergartens Fee from 2000 to 3000
		
	  New Rebate
		1. Domestic Tourism, capped at 1000, Multiple 
		2. Lifestyle - Sport, capped at 500, Multiple
  */
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Individual',9000,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Child',2000,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Life Ins PF',3000,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Parent Medical',8000,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Medical (Father)',1500,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Medical (Mother)',1500,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Supporting Equip',6000,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Disabled Person',6000,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Self Education',7000,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Serious Medical',8000,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'SSPN',8000,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Spouse',4000,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Educ Med Insurance',3000,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Disabled Spouse',5000,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Petrol Official',6000,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Parking',0,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Meal',0,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Childcare',2400,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Communication',0,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Employer Goods',1000,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Employer Service',0,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Loan Interest',0,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Other Medical',0,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Innovation',2000,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Compensation',20000,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Lve Passage',0,1,2);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Lve Passage Overseas',3000,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Foreign Insurance',0,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Group Insurance',0,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Alimony',4000,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Zakat Claim',0,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Annuity',3000,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'SOCSO Payment',250,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Perquisites',0,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Lifestyle Relief',2500,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'BreastFeedingEquip',1000,2,1);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Kindergartens Fee',3000,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'KWSP',4000,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Life Ins (P Pension)',7000,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Departure Levy',0,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Domestic Tourism',1000,1,0);
  Insert into RebateSetup(MalTaxPolicyProgSysId, RebateID, RebateCapAmt, RebateCapDuration, RebatePaymentOption) Values(In_MalTaxPolicyProgSysId+1,'Lifestyle - Sport',500,1,0);

  /* Create Other Tax Formula - no change in rate, use 2013 formula */
  insert into MalTaxFormula(MalTaxPolicyProgSysId, PolicyProgTaxScheme, MalSTDPolicyId) values(In_MalTaxPolicyProgSysId+1,'REP','REPYear2013');
  insert into MalTaxFormula(MalTaxPolicyProgSysId, PolicyProgTaxScheme, MalSTDPolicyId) values(In_MalTaxPolicyProgSysId+1,'ISKANDAR','ISKANDARYear2013');
  commit work;
end;

call dba.PatchMalaysiaTaxPolicyForRes();
drop procedure dba.PatchMalaysiaTaxPolicyForRes;

/*Begin of tailor for every patch*/
INSERT into "DBA"."subRegistry"(registryid,subregistryid,IntegerAttr) values('System','Patch',1);
commit work;
/*End of tailor for every patch*/