/*Begin of head for every patch*/
if exists(select * from "DBA"."subRegistry" WHERE registryid='System'and subregistryid='Patch')
then  
   Delete from SubRegistry where registryid='System'and subregistryid='Patch'
end if;
/*End of head for every patch*/

/*----------------------------
 SSS CONTRIBUTION wef JAN 2021
-----------------------------*/
/*----------------------------
 Insert Policy
-----------------------------*/
if not exists(select * from CPFPolicy where CPFPolicyId = 'SSSYr2021Jan' ) then
	Insert into CPFPolicy (CPFPolicyId, CPFGovernment, CPFPolicyDesc) Values('SSSYr2021Jan',1,'SSS for Year 2021');

	if not exists(select * from CPFTableCode  where CPFTableCodeId = 'SSS21') then
	  Insert into CPFTableCode (CPFTableCodeId, CPFResidenceTypeId, CPFSchemeId, CPFTableDesc, CPFPeriodCapping, CPFLessThanCapping, CPFGreaterThanCapping) Values('SSS21','Local','SSS','',0,0,0);
	  Insert into CPFPolicyMember (CPFPolicyId, CPFTableCodeId) Values('SSSYr2021Jan','SSS21');
	end if;

	/*------------------------------
	 Insert Formula
	--------------------------------*/
	if not exists(select * from Formula where Locate(FormulaId,'SSS21') = 1 and FormulaCategory='ManContriFormula') then

		/* Insert Formula */
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$0ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$3250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$3750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$4250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$4750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$5250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$5750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$6250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$6750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$7250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$7750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$8250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$8750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$9250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$9750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$10250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$10750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$11250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$11750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$12250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$12750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$13250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$13750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$14250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$14750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$15250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$15750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$16250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$16750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$17250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$17750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$18250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$18750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$19250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$19750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$0EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$3250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$3750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$4250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$4750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$5250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$5750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$6250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$6750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$7250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$7750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$8250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$8750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$9250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$9750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$10250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$10750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$11250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$11750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$12250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$12750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$13250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$13750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$14250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$14750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$15250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$15750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$16250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$16750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$17250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$17750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$18250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$18750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$19250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$19750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$0EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$3250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$3750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$4250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$4750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$5250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$5750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$6250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$6750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$7250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$7750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$8250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$8750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$9250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$9750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$10250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$10750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$11250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$11750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$12250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$12750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$13250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$13750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$14250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$14750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$15250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$15750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$16250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$16750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$17250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$17750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$18250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$18750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$19250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$19750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$0EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$3250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$3750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$4250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$4750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$5250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$5750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$6250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$6750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$7250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$7750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$8250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$8750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$9250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$9750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$10250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$10750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$11250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$11750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$12250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$12750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$13250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$13750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$14250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$14750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$15250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$15750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$16250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$16750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$17250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$17750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$18250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$18750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$19250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS21$19750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
		
		/* Insert FormulaRange */
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$0ERSS',1,0,0,'C1;',255,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$3250ERSS',1,0,0,'C1;',297.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$3750ERSS',1,0,0,'C1;',340,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$4250ERSS',1,0,0,'C1;',382.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$4750ERSS',1,0,0,'C1;',425,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$5250ERSS',1,0,0,'C1;',467.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$5750ERSS',1,0,0,'C1;',510,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$6250ERSS',1,0,0,'C1;',552.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$6750ERSS',1,0,0,'C1;',595,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$7250ERSS',1,0,0,'C1;',637.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$7750ERSS',1,0,0,'C1;',680,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$8250ERSS',1,0,0,'C1;',722.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$8750ERSS',1,0,0,'C1;',765,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$9250ERSS',1,0,0,'C1;',807.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$9750ERSS',1,0,0,'C1;',850,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$10250ERSS',1,0,0,'C1;',892.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$10750ERSS',1,0,0,'C1;',935,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$11250ERSS',1,0,0,'C1;',977.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$11750ERSS',1,0,0,'C1;',1020,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$12250ERSS',1,0,0,'C1;',1062.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$12750ERSS',1,0,0,'C1;',1105,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$13250ERSS',1,0,0,'C1;',1147.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$13750ERSS',1,0,0,'C1;',1190,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$14250ERSS',1,0,0,'C1;',1232.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$14750ERSS',1,0,0,'C1;',1275,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$15250ERSS',1,0,0,'C1;',1317.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$15750ERSS',1,0,0,'C1;',1360,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$16250ERSS',1,0,0,'C1;',1402.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$16750ERSS',1,0,0,'C1;',1445,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$17250ERSS',1,0,0,'C1;',1487.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$17750ERSS',1,0,0,'C1;',1530,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$18250ERSS',1,0,0,'C1;',1572.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$18750ERSS',1,0,0,'C1;',1615,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$19250ERSS',1,0,0,'C1;',1657.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$19750ERSS',1,0,0,'C1;',1700,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$0EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$3250EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$3750EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$4250EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$4750EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$5250EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$5750EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$6250EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$6750EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$7250EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$7750EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$8250EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$8750EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$9250EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$9750EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$10250EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$10750EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$11250EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$11750EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$12250EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$12750EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$13250EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$13750EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$14250EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$14750EREC',1,0,0,'C1;',30,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$15250EREC',1,0,0,'C1;',30,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$15750EREC',1,0,0,'C1;',30,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$16250EREC',1,0,0,'C1;',30,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$16750EREC',1,0,0,'C1;',30,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$17250EREC',1,0,0,'C1;',30,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$17750EREC',1,0,0,'C1;',30,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$18250EREC',1,0,0,'C1;',30,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$18750EREC',1,0,0,'C1;',30,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$19250EREC',1,0,0,'C1;',30,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$19750EREC',1,0,0,'C1;',30,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$0EESS',1,0,0,'C1;',135,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$3250EESS',1,0,0,'C1;',157.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$3750EESS',1,0,0,'C1;',180,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$4250EESS',1,0,0,'C1;',202.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$4750EESS',1,0,0,'C1;',225,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$5250EESS',1,0,0,'C1;',247.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$5750EESS',1,0,0,'C1;',270,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$6250EESS',1,0,0,'C1;',292.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$6750EESS',1,0,0,'C1;',315,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$7250EESS',1,0,0,'C1;',337.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$7750EESS',1,0,0,'C1;',360,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$8250EESS',1,0,0,'C1;',382.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$8750EESS',1,0,0,'C1;',405,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$9250EESS',1,0,0,'C1;',427.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$9750EESS',1,0,0,'C1;',450,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$10250EESS',1,0,0,'C1;',472.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$10750EESS',1,0,0,'C1;',495,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$11250EESS',1,0,0,'C1;',517.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$11750EESS',1,0,0,'C1;',540,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$12250EESS',1,0,0,'C1;',562.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$12750EESS',1,0,0,'C1;',585,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$13250EESS',1,0,0,'C1;',607.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$13750EESS',1,0,0,'C1;',630,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$14250EESS',1,0,0,'C1;',652.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$14750EESS',1,0,0,'C1;',675,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$15250EESS',1,0,0,'C1;',697.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$15750EESS',1,0,0,'C1;',720,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$16250EESS',1,0,0,'C1;',742.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$16750EESS',1,0,0,'C1;',765,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$17250EESS',1,0,0,'C1;',787.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$17750EESS',1,0,0,'C1;',810,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$18250EESS',1,0,0,'C1;',832.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$18750EESS',1,0,0,'C1;',855,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$19250EESS',1,0,0,'C1;',877.5,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$19750EESS',1,0,0,'C1;',900,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$0EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$3250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$3750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$4250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$4750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$5250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$5750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$6250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$6750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$7250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$7750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$8250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$8750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$9250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$9750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$10250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$10750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$11250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$11750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$12250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$12750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$13250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$13750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$14250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$14750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$15250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$15750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$16250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$16750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$17250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$17750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$18250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$18750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$19250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS21$19750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		
		/* Insert Table Component */
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',0,0,'SSS21$0EESS','SSS21$0ERSS',3250,99,'SSS21$0EEF2','SSS21$0EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',3250,0,'SSS21$3250EESS','SSS21$3250ERSS',3750,99,'SSS21$3250EEF2','SSS21$3250EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',3750,0,'SSS21$3750EESS','SSS21$3750ERSS',4250,99,'SSS21$3750EEF2','SSS21$3750EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',4250,0,'SSS21$4250EESS','SSS21$4250ERSS',4750,99,'SSS21$4250EEF2','SSS21$4250EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',4750,0,'SSS21$4750EESS','SSS21$4750ERSS',5250,99,'SSS21$4750EEF2','SSS21$4750EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',5250,0,'SSS21$5250EESS','SSS21$5250ERSS',5750,99,'SSS21$5250EEF2','SSS21$5250EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',5750,0,'SSS21$5750EESS','SSS21$5750ERSS',6250,99,'SSS21$5750EEF2','SSS21$5750EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',6250,0,'SSS21$6250EESS','SSS21$6250ERSS',6750,99,'SSS21$6250EEF2','SSS21$6250EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',6750,0,'SSS21$6750EESS','SSS21$6750ERSS',7250,99,'SSS21$6750EEF2','SSS21$6750EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',7250,0,'SSS21$7250EESS','SSS21$7250ERSS',7750,99,'SSS21$7250EEF2','SSS21$7250EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',7750,0,'SSS21$7750EESS','SSS21$7750ERSS',8250,99,'SSS21$7750EEF2','SSS21$7750EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',8250,0,'SSS21$8250EESS','SSS21$8250ERSS',8750,99,'SSS21$8250EEF2','SSS21$8250EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',8750,0,'SSS21$8750EESS','SSS21$8750ERSS',9250,99,'SSS21$8750EEF2','SSS21$8750EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',9250,0,'SSS21$9250EESS','SSS21$9250ERSS',9750,99,'SSS21$9250EEF2','SSS21$9250EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',9750,0,'SSS21$9750EESS','SSS21$9750ERSS',10250,99,'SSS21$9750EEF2','SSS21$9750EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',10250,0,'SSS21$10250EESS','SSS21$10250ERSS',10750,99,'SSS21$10250EEF2','SSS21$10250EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',10750,0,'SSS21$10750EESS','SSS21$10750ERSS',11250,99,'SSS21$10750EEF2','SSS21$10750EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',11250,0,'SSS21$11250EESS','SSS21$11250ERSS',11750,99,'SSS21$11250EEF2','SSS21$11250EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',11750,0,'SSS21$11750EESS','SSS21$11750ERSS',12250,99,'SSS21$11750EEF2','SSS21$11750EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',12250,0,'SSS21$12250EESS','SSS21$12250ERSS',12750,99,'SSS21$12250EEF2','SSS21$12250EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',12750,0,'SSS21$12750EESS','SSS21$12750ERSS',13250,99,'SSS21$12750EEF2','SSS21$12750EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',13250,0,'SSS21$13250EESS','SSS21$13250ERSS',13750,99,'SSS21$13250EEF2','SSS21$13250EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',13750,0,'SSS21$13750EESS','SSS21$13750ERSS',14250,99,'SSS21$13750EEF2','SSS21$13750EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',14250,0,'SSS21$14250EESS','SSS21$14250ERSS',14750,99,'SSS21$14250EEF2','SSS21$14250EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',14750,0,'SSS21$14750EESS','SSS21$14750ERSS',15250,99,'SSS21$14750EEF2','SSS21$14750EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',15250,0,'SSS21$15250EESS','SSS21$15250ERSS',15750,99,'SSS21$15250EEF2','SSS21$15250EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',15750,0,'SSS21$15750EESS','SSS21$15750ERSS',16250,99,'SSS21$15750EEF2','SSS21$15750EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',16250,0,'SSS21$16250EESS','SSS21$16250ERSS',16750,99,'SSS21$16250EEF2','SSS21$16250EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',16750,0,'SSS21$16750EESS','SSS21$16750ERSS',17250,99,'SSS21$16750EEF2','SSS21$16750EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',17250,0,'SSS21$17250EESS','SSS21$17250ERSS',17750,99,'SSS21$17250EEF2','SSS21$17250EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',17750,0,'SSS21$17750EESS','SSS21$17750ERSS',18250,99,'SSS21$17750EEF2','SSS21$17750EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',18250,0,'SSS21$18250EESS','SSS21$18250ERSS',18750,99,'SSS21$18250EEF2','SSS21$18250EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',18750,0,'SSS21$18750EESS','SSS21$18750ERSS',19250,99,'SSS21$18750EEF2','SSS21$18750EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',19250,0,'SSS21$19250EESS','SSS21$19250ERSS',19750,99,'SSS21$19250EEF2','SSS21$19250EREC');
		Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS21',19750,0,'SSS21$19750EESS','SSS21$19750ERSS',999999,99,'SSS21$19750EEF2','SSS21$19750EREC');

	end if;

	/* Set default SSS Policy */
	Update Subregistry Set ShortStringAttr = 'SSSYr2021Jan' 
	where RegistryId = 'PaySetupData' and SubregistryId = 'SSSProgPolicyId';

	/* Statutory Contribution Progression*/ 
	Insert into MandatoryContributeProg (EmployeeSysId, 
	MandContriEffDate,
	MandContriCareerId, 
	MandContriPolicyId, 
	MandContriCurrent,
	MandContriRemarks,
	MandContriSchemeId
	)
	Select CurProg.EmployeeSysId, 
	'2021-01-01', 
	'None',
	'SSSYr2021Jan', 
	0,
	'',
	'SSS'
	From PayEmployee PE join MandatoryContributeProg CurProg
	On PE.EmployeeSysId = CurProg.EmployeeSysId
	Left Join MandatoryContributeProg NewProg ON CurProg.EmployeeSysId = NewProg.EmployeeSysId and CurProg.MandContriSchemeId = NewProg.MandContriSchemeId 
	     and NewProg.MandContriEffDate = '2021-01-01'
	Where CurProg.MandContriCurrent = 1 and CurProg.MandContriEffDate < '2021-01-01' and CurProg.MandContriSchemeId = 'SSS' and CurProg.MandContriSchemeId != ''
	And NewProg.EmployeeSysId is null
	And (PE.LastPayDate = '1899-12-30' Or PE.LastPayDate >= '2021-01-01');


	/* Update progression if progression’s effective date is equal or greater than 2021-01-01, scheme is not blank & policy is SSSYr2019Apr */
	Update MandatoryContributeProg
	Set MandContriPolicyId = 'SSSYr2021Jan'
	Where MandContriEffDate >= '2021-01-01' 
	AND MandContriPolicyId = 'SSSYr2019Apr' And MandContriSchemeId = 'SSS'
	AND MandContriSchemeId != '';
end if;


/*Begin of tailor for every patch*/
INSERT into "DBA"."subRegistry"(registryid,subregistryid,IntegerAttr) values('System','Patch',1);
commit work;
/*End of tailor for every patch*/